#
## $URL: https://repos.ser.asu.edu/svn/lroc/lunaserv/tags/release_20160316/lunaserv/auth/ldap.rb $
## 
## Copyright (C) 2013 by Arizona State University and Mark Robinson.
## All rights reserved.
##
## This file has been released under the modified BSD license.
## See COPYING in the distribution package for details.
##
## Author: Nick Estes <nme@ser.asu.edu>
##
## $Author: nme $
##   $Date: 2013-07-29 12:35:08 -0700 (Mon, 29 Jul 2013) $
##    $Rev: 11956 $
##
#
require 'net/ldap'

module Lunaserv
  module Auth
    class Ldap
      attr_reader :name

      def initialize(name, config)
	@name = name
	@config = config
	
	raise "host must hold the server to authenticate with" unless @config[:host]
	raise "bind_template must hold a template to bind to LDAP with, \#{username} will be substituted for the username" unless @config[:bind_template]
	raise "tls must be set to true or false (ssl willbe used if tls is false)" unless (not @config[:tls].nil?) and [true, false].include? @config[:tls]
      end

      def auth(username, password)
	ldap = Net::LDAP.new(:host=>@config[:host], :port=>(@config[:tls] ? 389 : 636))
	Lunaserv.logger.debug ldap.inspect
	ldap.encryption(:simple_tls) #if @config[:tls]
	ldap.auth(@config[:bind_template].gsub('#{username}', username), password)
	ldap.bind
      end
    end
  end
end
