#
## $URL: https://repos.ser.asu.edu/svn/lroc/lunaserv/tags/release_20160316/lunaserv/db/postgres.rb $
## 
## Copyright (C) 2013 by Arizona State University and Mark Robinson.
## All rights reserved.
##
## This file has been released under the modified BSD license.
## See COPYING in the distribution package for details.
##
## Author: Nick Estes <nme@ser.asu.edu>
##
## $Author: nme $
##   $Date: 2013-08-07 14:34:42 -0700 (Wed, 07 Aug 2013) $
##    $Rev: 12066 $
##
#
require 'pg'

module Lunaserv
  module DB
    class Postgres
      def initialize(layer)
	@dbh = PG.connect(:dbname=>layer.dbname, :host=>layer.dbhost, :user=>layer.dbuser, :password=>layer.dbpassword)
      end

      def escape val
	if val.nil?
	  'NULL'
	else
	  "E'" + @dbh.escape_string(val.to_s) + "'"
	end
      end

      def exec sql
	@dbh.exec(sql)
      end
    end
  end
end
