#
## $URL: https://repos.ser.asu.edu/svn/lroc/lunaserv/tags/release_20160316/lunaserv/exception_maker.rb $
## 
## Copyright (C) 2013 by Arizona State University and Mark Robinson.
## All rights reserved.
##
## This file has been released under the modified BSD license.
## See COPYING in the distribution package for details.
##
## Author: Nick Estes <nme@ser.asu.edu>
##
## $Author: nme $
##   $Date: 2013-07-29 12:35:08 -0700 (Mon, 29 Jul 2013) $
##    $Rev: 11956 $
##
#
require 'rack/utils'

module Lunaserv
  class ExceptionMaker
    def self.run(exception)
      config = Lunaserv.config
      params = Lunaserv.params
      response = Lunaserv.response
      root = Lunaserv.root
      logger = Lunaserv.logger

      case params[:exceptions]
      when 'application/vnd.ogc.se_xml'
	if Lunaserv.environment == 'development'
	  response["Content-Type"] = "text/xml"
	else
	  response["Content-Type"] = "application/vnd.ogc.se_xml"
	end

	rhtml = ERB.new(File.read(File.join(root, "templates/exception.xml.erb")))
	rhtml.filename = "exception.xml.erb"
	response.body = [rhtml.result(binding)]
      when 'application/vnd.ogc.se_inimage'
	params[:format] ||= "image/png"
	params[:width] ||= 500
	params[:height] ||= 500
	dest_file = File.join(Lunaserv.tmpdir, "out.#{params[:format].split('/')[1]}")
	bgcolor = params[:transparent] ? '00000000' : params[:bgcolor].sub('0x','') + "ff"
	Open3.popen3 "map_render_exception", '-b', bgcolor, "-W", params[:width].to_s, '-H', params[:height].to_s, '-o', dest_file do |stdin, stdout, stderr|
	  stdin.sync = true
	  stdout.sync = true

	  stdin.puts exception.message
	  unless exception.is_a? Lunaserv::WmsError
	    stdin.puts "#{exception.class.to_s}: #{exception.backtrace.join("\n")}"
	  end

	  stdin.close
	  logger.debug "Command output:"
	  logger.debug stdout.read
	  logger.debug stderr.read
	end

	response["Content-Disposition"] = "inline; filename=lunaserv-tile.png"
	response["Content-Type"] = params[:format]
	response.body = [File.read(dest_file)]
      when 'application/vnd.ogc.se_blank'
	params[:format] ||= "image/png"
	params[:width] ||= 500
	params[:height] ||= 500
	bgcolor = params[:transparent] ? '00000000' : params[:bgcolor].sub('0x','') + "ff"

	dest_file = File.join(Lunaserv.tmpdir, "out.#{params[:format].split('/')[1]}")
	Open3.popen3 "map_render_exception", '-b', bgcolor, "-W", params[:width].to_s, '-H', params[:height].to_s, '-o', dest_file do |stdin, stdout, stderr|
	  stdin.sync = true
	  stdout.sync = true

	  stdin.close
	  stdout.read
	end

	response["Content-Disposition"] = "inline; filename=lunaserv-tile.png"
	response["Content-Type"] = params[:format]
	response.body = [File.read(dest_file)]
      else
	raise exception
      end
    end
  end
end
