#
## $URL: https://repos.ser.asu.edu/svn/lroc/lunaserv/tags/release_20160316/lunaserv/handler/get_capabilities.rb $
## 
## Copyright (C) 2013 by Arizona State University and Mark Robinson.
## All rights reserved.
##
## This file has been released under the modified BSD license.
## See COPYING in the distribution package for details.
##
## Author: Nick Estes <nme@ser.asu.edu>
##
## $Author: nme $
##   $Date: 2014-02-18 14:36:13 -0700 (Tue, 18 Feb 2014) $
##    $Rev: 13813 $
##
#
module Lunaserv
  module Handler
    class GetCapabilities
      def self.run
	self.new.run
      end

      def initialize
	@response = Lunaserv.response
	@base_url = Lunaserv.request.base_url
	@public = Lunaserv.dispatcher.public
	@body = Lunaserv.params[:body]
	self
      end

      def run
	@bboxes = {}
	Lunaserv::Projections.get_all.each do |match, string, proj, body, bbox_proc|
	  @bboxes[proj] = bbox_proc.call
	end

	if Lunaserv.environment == 'development'
	  @response["Content-Type"] = "text/xml"
	else
	  @response["Content-Type"] = "application/vnd.ogc.wms_xml"
	end

	rhtml = ERB.new(File.read(File.join(Lunaserv.root, "templates/get_capabilities.xml.erb")))
	rhtml.filename = "get_capabilities.xml.erb"
	@response.body = [rhtml.result(binding)]
      end
    end
  end
end
