#
# $URL: https://repos.ser.asu.edu/svn/lroc/lunaserv/tags/release_20160316/lunaserv/layers/night_base_layer.rb $
# 
# Copyright (C) 2013 by Arizona State University and Mark Robinson.
# All rights reserved.
#
# This file has been released under the modified BSD license.
# See COPYING in the distribution package for details.
#
# Author: Nick Estes <nme@ser.asu.edu>
#
# $Author: nme $
#   $Date: 2014-02-08 08:32:38 -0700 (Sat, 08 Feb 2014) $
#    $Rev: 13716 $
#
module Lunaserv
  module Layers
    class NightBaseLayer < MasterLayer
      def initialize(options)
	@options = options
      end

      def get_point
	point_call = [ self.body ]
	point_call << @options[:extra][:time] if @options[:extra][:time]

	Open3.popen3 "#{Lunaserv.root}/subsolar/get_point.rb", *point_call.collect(&:to_s) do |stdin, stdout, stderr|
	  stdin.close
	  stdout.read.split(' ')
	end
      end

      def render
	lon, lat = get_point

	options = []
	options += ['-p', @options[:proj]]
	options += ['-x', @options[:bbox][0]]
	options += ['-X', @options[:bbox][2]]
	options += ['-y', @options[:bbox][1]]
	options += ['-Y', @options[:bbox][3]]
	options += ['-W', @options[:width]]
	options += ['-H', @options[:height]]
	options += ['-o', @options[:outfile]]
	options += override_option '-C', :color, '000000'
	options += override_option '-O', :opacity, 'ff'
	options += ['-L', lon]
	options += ['-l', lat]

	system "map_day_night_layer", *(options.collect(&:to_s))
      end

      def self.check_defs(layer_def, messages)
	[:color, :opacity].each do |key|
	  messages << "Missing required key: #{key}" unless layer_def.keys.include? key
	end
	true
      end
    end
  end
end
