#
# $URL: https://repos.ser.asu.edu/svn/lroc/lunaserv/tags/release_20160316/lunaserv/layers/shading_base_layer.rb $
# 
# Copyright (C) 2013 by Arizona State University and Mark Robinson.
# All rights reserved.
#
# This file has been released under the modified BSD license.
# See COPYING in the distribution package for details.
#
# Author: Nick Estes <nme@ser.asu.edu>
#
# $Author: nme $
#   $Date: 2014-01-07 14:32:17 -0700 (Tue, 07 Jan 2014) $
#    $Rev: 13466 $
#
module Lunaserv
  module Layers
    class ShadingBaseLayer < MasterLayer
      def initialize(options)
	@options = options
      end

      def get_point
	@dbh = Lunaserv.db_module.new(self)
	result = @dbh.exec(apply_filters point_query)
	[result[0]['longitude'], result[0]['latitude']]
      end

      def render
	lon, lat = get_point

	options = []
	options += ['-p', @options[:proj]]
	options += ['-x', @options[:bbox][0]]
	options += ['-X', @options[:bbox][2]]
	options += ['-y', @options[:bbox][1]]
	options += ['-Y', @options[:bbox][3]]
	options += ['-W', @options[:width]]
	options += ['-H', @options[:height]]
	options += ['-o', @options[:outfile]]
	options += ['-C', self.color]
	options += ['-O', self.opacity]
	options += ['-L', lon]
	options += ['-l', lat]

	system "map_day_night_layer", *(options.collect(&:to_s))
      end

      def self.check_defs(layer_def, messages)
	[:color, :opacity, :dbhost, :dbuser, :dbpassword, :dbname, :point_query].each do |key|
	  messages << "Missing required key: #{key}" unless layer_def.keys.include? key
	end
	true
      end
    end
  end
end
