#!/usr/bin/env ruby
#
# $URL: https://repos.ser.asu.edu/svn/lroc/lunaserv/tags/release_20160316/subsolar/get_point.rb $
# 
# Copyright (C) 2013 by Arizona State University and Mark Robinson.
# All rights reserved.
#
# This file has been released under the modified BSD license.
# See COPYING in the distribution package for details.
#
# Author: Nick Estes <nme@ser.asu.edu>
#
# $Author: nme $
#   $Date: 2013-08-14 16:36:21 -0700 (Wed, 14 Aug 2013) $
#    $Rev: 12128 $
#

require 'rubygems'
require 'spice'
require 'date'

include Spice

Dir[File.join(File.dirname(__FILE__), '*')].each do |kernel|
  next if kernel =~ /rb$/
  furnsh kernel
end

if ARGV[1]
  begin
    dt = DateTime.parse(ARGV[1].sub('T', ' '))
    et = rb2et(Time.gm(dt.year, dt.month, dt.day, dt.hour, dt.min, dt.sec))
  rescue Exception
  end
end

et ||= rb2et Time.now

puts reclat(subslr("Near Point: Ellipsoid", ARGV[0], et, 'iau_'+ARGV[0], 'none', 'sun')[0])[1..2].collect {|p| p*dpr}.join(" ")
